/*

    This file requires site.js to work

*/


var Site = Site || {},
    $window = $window || $(window),
    $body = $body || $("body");


    (function($){
        Site.Animation = {

            // shiftLine: new TimelineLite(),
            // unShiftLine: new TimelineLite(),

            hideContent: function() {
                // $("#content")



                    // var h = $window.height(),
                    // bgColor = Site.PushStates.nextBgColor || Site.defaultColor;

                    // $mask = $('<div class="mask" id="mask" style="background: '+bgColor+'; height: '+h+'px;" />');

                    // $mask.appendTo("#content");

                    // TweenMax.fromTo($mask, 0.6, {x: 0, y: h, z: 0}, {x: 0, y: 0, z: 0, ease:Quart.easeOut, overwrite: true});

                   
                



                if ( ( Site.PushStates.newPage.split("/").length > 3 && Site.PushStates.newPage.split("/")[2] === "artist" ) || ( Site.PushStates.newPage.split("/").length > 4 && Site.PushStates.newPage.split("/")[2] === "path"  ) ) {


                    var h = $window.height(),
                    bgColor = Site.PushStates.nextBgColor || "#fff";

                    $mask = $('<div class="mask" id="mask" style="background: '+bgColor+'" />');

                    $mask.appendTo("#content");

                    TweenMax.fromTo($mask, 0.6, {x: 0, y: h, z: 0}, {x: 0, y: 0, z: 0, ease:Quart.easeOut, overwrite: true});

                    return;
        
                }
                if ( ( Site.PushStates.oldPage.split("/")[2] === "artist" && Site.PushStates.newPage.split("/")[2] === "artists"  ) 

                     || ( Site.PushStates.oldPage.split("/").length > 4 && Site.PushStates.oldPage.split("/")[2] === "path" && Site.PushStates.newPage.split("/").length === 4 && Site.PushStates.newPage.split("/")[2] === "path"  ) )
                {

                    // $("#content")
                    TweenMax.to($("#artist").find(".artist-gallery-container, .artist-info"), 0.4, {autoAlpha: 0}); 

                    // var bgColor = Site.PushStates.nextBgColor || "#fff",

                    // $mask = $('<div class="mask" id="mask" style="background: '+bgColor+'; z-index: 1 !important;" />');
                    // $mask.appendTo("#content");

                    // var h = $window.height(),
                    // bgColor = Site.PushStates.nextBgColor || "#fff";

                    // $mask = $('<div class="mask" id="mask" style="background: '+bgColor+'" />');

                    // $mask.appendTo("#content");

                    // var $artist = $("#artist");

                    // $artist.css({
                    //     "overflow": "hidden",
                    //     "position": "absolute",
                    //     "width":    "100%",
                    //     "height":   "100%",
                    //     "minHeight": 0,
                    //     "bottom":   0,
                    //     "left":      0
                    // });

                    // TweenMax.to($artist, 0.6, {height: 0, ease:Quart.easeOut, overwrite: true, onComplete: function(){
                    //     $("#content").css("opacity",0);
                    // }});

                    return;
                }

                TweenMax.to("#content", 0.4, {autoAlpha: 0});
                return;

              


            },

            showContent: function() {

                if ((  Site.PushStates.oldPage.split("/")[2] === "artist" && Site.PushStates.newPage.split("/")[2] === "artists"  )
                    
                     || ( Site.PushStates.oldPage.split("/").length > 4 && Site.PushStates.oldPage.split("/")[2] === "path" && Site.PushStates.newPage.split("/").length === 4 && Site.PushStates.newPage.split("/")[2] === "path"  ) )

                 {
                     var h = $window.height(),
                    bgColor = "#fff";

                    $mask = $('<div class="mask" id="mask" style="background: '+bgColor+'" />');

                    $mask.appendTo("#content");

                    TweenMax.fromTo($mask, 0.6, {x: 0, y: 0, z: 0}, {x: 0, y: h, z: 0, ease:Quart.easeOut, overwrite: true, onComplete: function() {
                        $mask.remove();
                    }});


                }
                // $("#content")
                TweenMax.to($("#content"), 0.4, {autoAlpha: 1});
            },


            init: function() {

                Site.Animation.showContent();

                // if ( $("#artist").length ) {
                //     $("#top-line").addClass("is-shifted-left");
                // }

                // TweenMax.to("#top-line", 0.4, {opacity: 1, onComplete: function(){ 
                    // $body.removeClass("is-before-load");
                // }});


               
                          
            },

            onLoad: function() {
                 Site.Animation.bindAnimations();
            },

            bindAnimations: function(){

                // if ( ! "LuCanvas" in Site ) return;

                // $(".main-menu, .artists-list").find("a").off().on("mouseenter", function() {
                //     Site.LuCanvas.changeText($(this).attr("href"));
                // }).on("mouseleave", function() {
                //     Site.LuCanvas.changeText();
                // });
            },

            doShift: function() {
                // Shifts the element 50% to the middle
                // Site.Animation.shiftLine.play();
            },

            moveLineLeft: function() {


                // if($("#top-line").hasClass("is-shifted-left")) return;


                // var wWidth = $window.width();
                
                // TweenMax.to("#top-line", 0.4, {x: -wWidth/2 + 40, onComplete: function() {
                //     $("#top-line").removeAttr("style").addClass("is-shifted-left");
                // }});

            },
            moveLineRight: function() {

                // if(!$("#top-line").hasClass("is-shifted-left")) return;

                // var wWidth = $window.width();
                // TweenMax.to("#top-line", 0.4, {x: wWidth/2 - 40, onComplete: function() {
                //     $("#top-line").removeAttr("style").removeClass("is-shifted-left");
                // }});                
            },

            

            states: {

                slideUp: function(data) {

               
                    var newContent = $(data).find("#content").children(),
                    h = $window.height(),
                    oldArtist = $("#content").find(".artist"),
                    newArtist = null,
                    delay = (Site.GalleryView.states.enlarged) ? 0.4 : 0,

                    info = $("#artist").find(".artist-info-content"),

                    container = $("#artist").find(".artist-gallery-container");



                    if( delay > 0) {
                        
                        Site.GalleryView.unEnlarge();

                    }

                    // change the id so it's not affected by JS
                    oldArtist.find("#gallery").attr("id","old-gallery");

                    newContent.find("#gallery").appendTo(container);


                    TweenMax.fromTo(info.children().not(".artist-info-static"), 0.6, {opacity: 1}, {delay: delay, opacity: 0}); 

                    // TweenMax.fromTo( $("#old-gallery").find(".gallery-next, .gallery-prev, .gallery-next-artist, .gallery-prev-artist"), 0.3, {opacity: 1}, {delay: delay, opacity: 0}); 

                    TweenMax.fromTo(container, 0.6, {x: 0, y: 0, z: 0}, {delay: delay, x: 0, y: -h, z: 0, ease:Quart.easeInOut, overwrite: true, onComplete: function() {

                        $("#old-gallery").remove();

                        // oldArtist.remove();

                        container.removeAttr("style");
                        $("#content").css("opacity", 1);

                        info.html( newContent.find(".artist-info-content").html() );

                        TweenMax.fromTo(info.children().not(".artist-info-static"), 0.6, {opacity: 0}, {opacity: 1}); 
                        
                        Site.GalleryView.onLoad();
                        Site.Scrolling.onLoad();



                    }, onStart: function() {
                        Site.PushStates.bindLinks();
                    }});

                },

                
                slideDown: function(data) {

               
                    var newContent = $(data).find("#content").children(),
                    h = $window.height(),
                    oldArtist = $("#content").find(".artist"),
                    newArtist = null,
                    delay = (Site.GalleryView.states.enlarged) ? 0.4 : 0,

                    info = $("#artist").find(".artist-info-content"),

                    container = $("#artist").find(".artist-gallery-container");

                    if( delay > 0) {
                        Site.GalleryView.unEnlarge();
                    }


                    oldArtist.find("#gallery").attr("id","old-gallery");


                    newContent.find("#gallery").css("marginTop",-h).prependTo( container );



                    TweenMax.fromTo( info.children().not(".artist-info-static"), 0.6, {opacity: 1}, {delay: delay, opacity: 0}); 

                    TweenMax.fromTo( container, 0.6, {x: 0, y: 0, z: 0}, {delay: delay, x: 0, y: h, z: 0, ease:Quart.easeInOut, overwrite: true, onComplete: function() {

                        container.removeAttr("style");

                        $("#content").css("opacity", 1);

                        $("#gallery").removeAttr("style");
                        
                        $("#old-gallery").remove();

                        info.html( newContent.find(".artist-info-content").html() );


                        TweenMax.fromTo(info.children().not(".artist-info-static"), 0.6, {opacity: 0}, {opacity: 1}); 

                        Site.Scrolling.onLoad();
                        Site.GalleryView.onLoad();



                    }, onStart: function() {
                        Site.PushStates.bindLinks();
                    }});


                }
            },

            old_states: {
                slideUp: function(data) {

               
                    var newContent = $(data).find("#content").children(),
                    h = $window.height(),
                    oldArtist = $("#content").find(".artist").attr("id","old-artist"),
                    newArtist = null,
                    delay = (Site.GalleryView.states.enlarged) ? 0.4 : 0;



                    if( delay > 0) {
                        
                        Site.GalleryView.unEnlarge();
                        // oldArtist.removeClass("is-enlarged");
                    }

                    oldArtist.find("#gallery").attr("id","old-gallery");
                    oldArtist.find("#artist-info").attr("id", "old-artist-info");

                    newContent.appendTo($("#content"));


                    // Site.onLoad();

                    newArtist = $("#content").find(".artist").eq(1);
                    

                    TweenMax.fromTo("#content", 0.6, {x: 0, y: 0, z: 0}, {delay: delay, x: 0, y: -h, z: 0, ease:Quart.easeInOut, overwrite: true, onComplete: function() {


                        oldArtist.remove();

                        $("#content").removeAttr("style")
                        .css("opacity", 1);
                        
                        Site.Scrolling.onLoad();



                    }, onStart: function() {
                        Site.GalleryView.onLoad();
                        Site.PushStates.bindLinks();
                    }});

                },

                
                slideDown: function(data) {

               
                    var newContent = $(data).find("#content").children(),
                    h = $window.height(),
                    oldArtist = $("#content").find(".artist").attr("id","old-artist"),
                    newArtist = null,
                    delay = (Site.GalleryView.states.enlarged) ? 0.4 : 0;

                    if( delay > 0) {
                        // oldArtist.removeClass("is-enlarged");
                        Site.GalleryView.unEnlarge();
                    }


                    oldArtist.find("#gallery").attr("id","old-gallery");


                    newContent.css("marginTop",-h).prependTo($("#content"));

                    newArtist = $("#content").find(".artist").eq(0);


                    TweenMax.fromTo("#content", 0.6, {x: 0, y: 0, z: 0}, {delay: delay, x: 0, y: h, z: 0, ease:Quart.easeInOut, overwrite: true, onComplete: function() {

                        $("#content").removeAttr("style")
                        .css("opacity", 1);
                        newArtist.removeAttr("style");
                        
                        oldArtist.remove();

                        Site.Scrolling.onLoad();


                    }, onStart: function() {
                        Site.GalleryView.onLoad();
                        Site.PushStates.bindLinks();
                    }});


                }
            }
        };
    }(jQuery));

