/*

    This file requires site.js to work

*/


var Site = Site || {};


    (function($){
        Site.Scrolling = {

            conditions: function() {

              // return true;

              if (Modernizr.touch) return false;
              if ((navigator.userAgent.indexOf('Mac OS X') != -1)) return false;

              return true;

            },

            onLoad: function() {

                if (!Site.Scrolling.conditions()) {
                  $body.addClass("has-nice-scroll");
                  return;
                }

                var scroll = $("[data-scrollable]");

                if(scroll) {
                  scroll.niceScroll({
                    railoffset: {
                      left: ($("#artists").length) ? -12 : 0
                    },
                    cursoropacitymax: 0.7,
                    cursorborder: 0
                  });
                }

            },
            onUnLoad: function() {
              var api = $("[data-scrollable]").data("__nicescroll");
              if( !api ) return;
              api.remove();
            }
        };

    }(jQuery));

